
%%%% This script operates given the variable node weight sequence Ds and
%%%% produces a graph for the code with Rate R = 1/2


tic

N_bits = length(Ds);
m_Chks = N_bits/2;

N= N_bits;
M = m_Chks;

K = N-M;

pre_tanner=zeros(m_Chks,N_bits);

D_chk = sum(pre_tanner,2);
D_var = sum(pre_tanner);

for j=1:N_bits
    
    for k=1:Ds(j)
        if k==1
            choices = find(D_chk==min(D_chk));
            m_index = (choices(ceil(length(choices).*rand(1))));
            
            pre_tanner(m_index,j)=1;
            D_chk(m_index)=D_chk(m_index)+1;
            D_var(j)=D_var(j)+1;
        else 
            level_count = 0;
            level = 0;
            N_sj=find(pre_tanner(:,j));
            N_sj_pi=setdiff(1:m_Chks,N_sj);
            
            while(~isempty(N_sj_pi))
                level = level +1;
                level_count = level_count+1;
                N_sj_pi_pre=N_sj_pi;
                Depth_chks=[];
                for kk=1:length(N_sj);
                    temp_bits=find(pre_tanner(N_sj(kk),:));
                    for nn=1:length(temp_bits)
                        temp_chks=find(pre_tanner(:,temp_bits(nn)));
                        Depth_chks=union(Depth_chks,temp_chks);
                    end
                end
                N_sj=Depth_chks;
                N_sj_pi=setdiff(1:m_Chks,N_sj);
                
                if length(N_sj_pi)==length(N_sj_pi_pre)
                    break;
                end
                
            end
   
            temp_D_chk=D_chk(N_sj_pi_pre);
            
            candidates = N_sj_pi_pre(logical(temp_D_chk==min(temp_D_chk)));
            
  
            if (isempty(N_sj_pi))
                Level_Reached = level;
                cand_EMD_vectors = zeros(m_Chks, length(candidates));
                
                cands_isolator = [];
                c_p_e_v_index = 1;
                cands_ind = zeros(1,length(candidates));
                for b = 1:length(candidates)
                    starting_CN = candidates(b);
                    [~,PATH_MATRIX] = TreeExpansion_EMD_for_submission(starting_CN, pre_tanner(:,1:j), Level_Reached, j);
                    
                    PM = zeros(size(PATH_MATRIX,1), max(sum(PATH_MATRIX,2)));
                    for dvari = 1:size(PATH_MATRIX,1)
                        PM(dvari,1:length( find(PATH_MATRIX(dvari,:)))) = find(PATH_MATRIX(dvari,:));
                    end
                    
                    
                    [Paths, index] = PathFinder_for_submission(PM, pre_tanner(:,1:j));
                    
                    for dvaria = 1:size(Paths,2)
                        cand_paths_EMD_vectors(:,c_p_e_v_index+dvaria-1) = sum(pre_tanner(:,Paths(:,dvaria)'),2);
                    end
                    
                    c_p_e_v_index = c_p_e_v_index+size(Paths,2);
                    cands_ind(b) = size(Paths,2);
                    cands_isolator = [cands_isolator b*ones(1,size(Paths,2))];
                end
               
                option_indices = find(cands_ind==min(cands_ind));
                options = candidates(option_indices);
                EMD_Metric = zeros(1, length(options));
                if length(options)==1
                    choice = options;

                    EMD_Metric = mean(sum(cand_paths_EMD_vectors(:,cands_isolator==option_indices)==1));

                else
                    for arb_var = 1:length(options)
                        EMD_Metric(arb_var) = mean(sum(cand_paths_EMD_vectors(:,cands_isolator==option_indices(arb_var))==1));
                    end
                    refined_options = options(EMD_Metric==max(EMD_Metric));
                    
                    choice = (refined_options(ceil(length(refined_options).*rand(1))));

                end
                
            else
                choice =  (candidates(ceil(length(candidates).*rand(1))));
            end

            
            chosenCN = choice;
            pre_tanner(chosenCN,j)=1;
            D_chk(chosenCN)=D_chk(chosenCN)+1;
            
            
        end
    end
end

PCM = pre_tanner;


constr_time = toc;